let () = Gc.set ( { (Gc.get ()) with Gc.minor_heap_size = 2*1024*1024 } )
module X = struct
  type 'a t = 'a Zipper.t
  open Zipper
  let empty = empty
  let add t e = add t { where = Here } e
  let remove = remove
  let get = get
  let length = length
  let pos = pos
  let nth = nth
  module Iter = struct
    type 'a iter = int
    let to_pos _t iter = iter
    let of_pos _t i = i
    let of_set = pos
    let next t iter = of_pos t (1 + to_pos t iter)
  end
end

module Y = Listview.CustomListView(X)

let fill column_list l =
  List.iter column_list#insert l

let () =
  ignore (GtkMain.Main.init ());
  let column_list = new GTree.column_list in
  let col_int = column_list#add Gobject.Data.int in
  let view_col = GTree.view_column ~title:"Value"
    ~renderer:(GTree.cell_renderer_text [], [ "text", col_int]) () in
  let custom_model = new Y.model column_list in
  fill custom_model (Array.to_list (Array.make 100_000 [`INT 42]));
  let view = GTree.view ~model:custom_model () in
  view#append_column view_col;
  let window = GWindow.window ~width:200 ~height:400 () in
  ignore (window#event#connect#delete ~callback:(fun _ -> exit 0));
  let scroll = GBin.scrolled_window ~packing:window#add () in
  scroll#add view#coerce;
  window#show ();
  GtkMain.Main.main ()

